; AdBlock+ setup 1.0.5 by A.Ruzanov
; 05.11.2009


#NoTrayIcon

$MP = "Select a Opera folder in the list below, then click OK."
$MOK = "Setup has finished installing AdBlock+ on your computer"

$AdBlockMenu = "AdBlock+"
$Block = "Block element"
$UnBlock = "Unblock latest element"
$Accept = "Accept changes and reload stylesheets"
$BlockQuestion = "Block this element(s)?"

Select
	Case @OSLang = 0419
		$MP = "    Opera"
	Case StringInStr("0407,0807,0c07,1007,1407", @OSLang)
		$MP = "Whlen Sie Ihr Opera-Installationsverzeichnis aus und klicken Sie auf OK."
	Case StringInStr("040a,080a,0c0a,100a,140a,180a,1c0a,200a,240a,280a,2c0a,300a,340a,380a,3c0a,400a,440a,480a,4c0a,500a", @OSLang)
		$MP = "Seleccionar la carpeta de Opera de la siguiente lista, despus click OK."
EndSelect


$StartDir = @ScriptDir
If Not FileExists($StartDir & "\opera.exe") Then
	$StartDirArr = StringSplit(StringLower(RegRead("HKEY_CURRENT_USER\Software\Opera Software", "Last CommandLine v2")), "\opera.exe ", 1)
	If IsArray($StartDirArr) Then $StartDir = $StartDirArr[1]
EndIf
If Not FileExists($StartDir & "\opera.exe") Then $StartDir = RegRead("HKEY_CURRENT_USER\Software\Opera Software", "Last Directory3")
If Not FileExists($StartDir & "\opera.exe") Then $StartDir = ""

$OperaDir = FileSelectFolder($MP, "", 0, $StartDir)
If @error Then Exit

$ver = StringSplit(FileGetVersion($OperaDir & "\Opera.dll"), ".")
$Version = $ver[1] & "." & $ver[2]
$isOpera10 = $ver[1] >= 10 And $ver[3] >= 1413

If $isOpera10 Then
	$o6Defini = $OperaDir & "\operaprefs_default.ini"
	$o6ini = "operaprefs.ini"
	$defFolder = $OperaDir & "\ui"
Else
	$o6Defini = $OperaDir & "\OperaDef6.ini"
	$o6ini = "opera6.ini"
	$defFolder = $OperaDir & "\defaults"
EndIf

If IniRead($o6Defini, "System", "Multi User", "1") = 1 Then
	$VarOpDir = StringSplit($OperaDir, "\")
	$NameDir = $VarOpDir[UBound($VarOpDir) - 1]
	$OperaProfileDir = @AppDataDir & "\opera\" & $NameDir
	If Not $isOpera10 Then $OperaProfileDir = $OperaProfileDir & "\profile"
Else
	$OperaProfileDir = $OperaDir & "\profile"
EndIf

$VarMenu = $OperaProfileDir & "\menu\"
$VarOpera6 = $OperaProfileDir & "\" & $o6ini
$LangPath = IniRead($VarOpera6, "User Prefs", "Language File", "")
$LangName = StringMid($LangPath, StringInStr($LangPath, "\", 0, -1) + 1)
$MenuPath = IniRead($VarOpera6, "User Prefs", "Menu Configuration", "")
$OperaProfileDirUtf = __StringToUTF($OperaProfileDir)

Select
	Case $LangName = "english.lng"
		$Language = 0409
	Case $LangName = "ru.lng"
		$Language = 0419
	Case $LangName = "russian.lng"
		$Language = 0419
	Case $LangName = "es-ES.lng"
		$Language = "040a"
	Case $LangName = "es-LA.lng"
		$Language = "080a"
	Case $LangName = "de.lng"
		$Language = 0407
	Case $LangName = "zh-CN.lng"
		$Language = 0804
	Case $LangName = "zh-TW.lng"
		$Language = 0404
	Case Else
		$Language = @OSLang
EndSelect


If $Language = 0419 Then
	$MOK = "  "
	$Block = "Заблокировать элемент страницы"
	$UnBlock = "Разблокировать последний элемент"
	$Accept = "Принять изменения и перезагрузить стили"
	$BlockQuestion = "Заблокировать данный элемент?"
EndIf

DirCreate($OperaProfileDir & "\AdBlock")
FileInstall("Adblock.exe", $OperaProfileDir & "\AdBlock\Adblock.exe", 1)
FileInstall("Adblock+.css", $OperaProfileDir & "\styles\user\Adblock+.css", 0)

IniWrite($VarOpera6, "File Types Section Info", 'Version', '2')
IniWrite($VarOpera6, "File Types", 'text/adblock', '7,' & $OperaProfileDirUtf & '\AdBlock\Adblock.exe,,,,|')
IniWrite($VarOpera6, "File Types Extension", 'text/adblock', ',128')


$VarDefMenu = $defFolder & "\standard_menu.ini"

$VarSearchM = FileFindFirstFile($VarMenu & "*.ini")
If $VarSearchM = -1 Or $MenuPath = $VarDefMenu Then
	$VarOperaMenu = $VarDefMenu
	Correct($VarOperaMenu, $VarDefMenu, $OperaDir)
Else
	While 1
		$VarOperaMenu = $VarMenu & FileFindNextFile($VarSearchM)
		If @error Then ExitLoop
		Correct($VarOperaMenu, $VarDefMenu, $OperaDir)
	WEnd
	FileClose($VarSearchM)
EndIf

MsgBox(64, "AdBlock+ setup", $MOK, 10)
Exit

Func __StringToUTF($sString)
	Local $sResult = "", $iCode
	Local $aUTF_Split = StringSplit($sString, "")
	
	For $i = 1 To $aUTF_Split[0]
		$iCode = Asc($aUTF_Split[$i])
		
		Select
			Case $iCode >= 192 And $iCode <= 239
				$aUTF_Split[$i] = Chr(208) & Chr($iCode - 48)
			Case $iCode >= 240 And $iCode <= 255
				$aUTF_Split[$i] = Chr(209) & Chr($iCode - 112)
			Case $iCode = 168
				$aUTF_Split[$i] = Chr(208) & Chr(129)
			Case $iCode = 184
				$aUTF_Split[$i] = Chr(209) & Chr(145)
			Case Else
				$aUTF_Split[$i] = Chr($iCode)
		EndSelect
		
		$sResult = $sResult & $aUTF_Split[$i]
	Next
	
	Return $sResult
EndFunc   ;==>__StringToUTF

Func Transfer($Home)
	Local $VarBTM = IniReadSection($VarOperaMenu, $Home)
	If @error Then
		Local $VarHNDL = FileOpen($VarOperaMenu, 1)
		Local $VarDefHNDL = FileOpen($VarDefMenu, 0)
		Local $BTM = ""
		While $BTM <> "[" & $Home & "]"
			$BTM = FileReadLine($VarDefHNDL)
		WEnd
		
		$BTM = @CRLF & $BTM
		
		Do
			FileWriteLine($VarHNDL, $BTM)
			$BTM = FileReadLine($VarDefHNDL)
		Until StringLeft($BTM, 1) = "[" Or StringLeft($BTM, 2) = ";["
		FileClose($VarHNDL)
		FileClose($VarDefHNDL)
	EndIf
EndFunc   ;==>Transfer

Func Correct($VarOperaMenu, $VarDefMenu, $OperaDir)
	Local $VarBak = $VarOperaMenu & "_1.bak"
	If FileExists($VarBak) Then
		Local $Num = 2
		While FileExists($VarOperaMenu & "_" & $Num & ".bak")
			$Num = $Num + 1
		WEnd
		$VarBak = $VarOperaMenu & "_" & $Num & ".bak"
	EndIf
	
	FileCopy($VarOperaMenu, $VarBak, 1)
	
	Transfer("Document Popup Menu")
	IniWrite($VarOperaMenu, "Document Popup Menu", '--------------------', '')
	IniWrite($VarOperaMenu, "Document Popup Menu", 'Submenu, "' & $AdBlockMenu & '", AdBlock Menu', '')
	
	IniWrite($VarOperaMenu, "AdBlock Menu", 'Item, "' & $Block & '"', 'Go to page, "javascript:(function(){if(window.navigator.ujs_AdBlock){return}else{window.navigator.ujs_AdBlock=true};var ele='''',outline='''',border='''',bgColor='''',title='''',reObjects=/^(iframe|object|embed)$/i;var doc=((window.document.body instanceof HTMLFrameSetElement)?window.frames[0]:window).document;var createStyle=function(css){var s=doc.createElement(''style'');s.setAttribute(''type'',''text/css'');s.appendChild(doc.createTextNode(css));return(doc.getElementsByTagName(''head'')[0]||doc.documentElement).appendChild(s)};var getAtt=function(ele,tags){var rez='''';if(ele.attributes){var r=new RegExp(''^(''+tags+'')$'');for(var i=0,a;a=ele.attributes[i];i++){var n=a.nodeName.toLowerCase();if(r.test(n))rez+=''[''+n+''=\x22''+a.nodeValue.replace(/[\x22\x5C]/g,''\\$&'')+''\x22]''}};return rez};var getNth=function(ele){var nth,n=0,p=ele.parentNode;for(var i=0,c;c=p.childNodes[i];i++){if(c.nodeType==1){n++;if(c==ele)nth=n}};return(!nth||n<2)?'''':'':nth-child(''+nth+'')''};var getCssRules=function(el,wide){var att,tag,rez=[];while(el){if(el.nodeType==1){att=getAtt(el,''src'')||getAtt(el,''href'');tag=el.nodeName;if(att){rez.unshift(tag+(wide?att.replace(/^(\[\w+)(=\x22[^?#]+\/).*(\x22\])$/,''$1^$2$3''):att));break}else{rez.unshift(tag+getAtt(el,''id|class|height|width|color|bgcolor|align'')+((wide||/^(html|body)$/i.test(tag)||!window.postMessage)?'''':getNth(el)))}};el=el.parentNode};return rez.join('' > '')};var remove=function(){doc.removeEventListener(''mouseover'',over,false);doc.removeEventListener(''mouseout'',out,false);doc.removeEventListener(''click'',click,false);doc.removeEventListener(''keyup'',press,false);delete window.navigator.ujs_AdBlock};var over=function(ev){ele=ev.target;title=ele.title;ele.title=''Tag: ''+ele.nodeName+(ele.id?'', ID: ''+ele.id:'''')+(ele.className?'', Class: ''+ele.className:'''');if(reObjects.test(ele.nodeName)){border=ele.style.border;ele.style.border=''2px solid #306EFF''}else{outline=ele.style.outline;ele.style.outline=''1px solid #306EFF'';bgColor=ele.style.backgroundColor;ele.style.backgroundColor=''#C6DEFF''}};var out=function(){if(ele){ele.title=title;if(reObjects.test(ele.nodeName)){ele.style.border=border}else{ele.style.outline=outline;ele.style.backgroundColor=bgColor}}};var click=function(ev){var css,tmp;if(ele&&(css=getCssRules(ele,ev.altKey))){ev.preventDefault();out();remove();tmp=createStyle(css+''{background-color: #FF5555 !important; outline: 1px solid #FF1111 !important; opacity: 0.7 !important;}'');css=prompt(''' & $BlockQuestion & ''',css);if(css){createStyle(css+''{display: none !important;}'');window.location.href=''data:text/adblock;charset=UTF-8,''+encodeURIComponent(css)};tmp.parentNode.removeChild(tmp)}};var press=function(ev){if(ev.keyCode==27){out();remove()}};doc.addEventListener(''mouseover'',over,false);doc.addEventListener(''mouseout'',out,false);doc.addEventListener(''click'',click,false);doc.addEventListener(''keyup'',press,false)})()", , , "Delete"')
	IniWrite($VarOperaMenu, "AdBlock Menu", 'Item, "' & $UnBlock & '"', 'Go to page, "javascript:(function(){var styles=document.getElementsByTagName(''style'');var s=styles[styles.length-1];if(s&&/{display: none !important;}$/.test(s.innerHTML))s.parentNode.removeChild(s);location.href=''data:text/adblock;charset=UTF-8,/unblock''})()",,,"Mail Redirected"')
	IniWrite($VarOperaMenu, "AdBlock Menu", 'Item, "' & $Accept & '"', 'Go to page, "javascript:location.href=''data:text/adblock;charset=UTF-8,/clear''",,,"Transfer Loading" & Reload stylesheets')
	
	
EndFunc   ;==>Correct
